package com.kexun.controller;

//import ch.qos.logback.core.rolling.helper.FileStoreUtil;
//import ch.qos.logback.core.util.FileUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.kexun.common.utils.Result;
import com.kexun.entity.*;
import com.kexun.service.CooperatorProductFieldService;
import com.kexun.service.CooperatorProductService;
import com.kexun.service.CooperatorService;
import lombok.extern.java.Log;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.List;

/*
新添加
 * 目标：合作方相关操作接口
 * 目前：目前只有增、查合作方，
 此外，由组合字段过滤到模型进行逻辑判断的整体的解析逻辑打通还需改动
 */

@RestController
@RequestMapping("/admin/cooperator")
@Log
public class CooperatorController {

    @Autowired
    private CooperatorService CooperatorService;

    @Autowired
    private CooperatorProductService CooperatorProductService;


    @Autowired
    private CooperatorProductFieldService CooperatorProductFieldService;

    // 获取合作方信息
    @RequestMapping("cooperatorList")

    public Result cooperatorList(@RequestBody String json) {
        JSONObject req = JSON.parseObject(json);
        int pageNum = req.getIntValue("pageNum");
        int pageSize = req.getIntValue("pageSize");

        PageHelper.startPage(pageNum, pageSize);//设置分页信息
        JSONObject resJson=new JSONObject();
        List<CooperatorInfo> list= CooperatorService.selectPage();

        for(int i=0; i<list.size(); i++)
        {
            String time = list.get(i).getCreateTime().replace(".0","");
            list.get(i).setCreateTime(time);
        }
        PageInfo pageInfo=new PageInfo(list);
        resJson.put("cooperator_List",pageInfo);

        return Result.success("ok",resJson);
    }

    //模糊查询
    @RequestMapping("selectCooperator")

    public Result selectCooperator(@RequestBody String json) {
        JSONObject req = JSON.parseObject(json);
        int pageNum = req.getIntValue("pageNum");
        int pageSize = req.getIntValue("pageSize");
        String cooperatorName = req.getString("cooperatorName");
        PageHelper.startPage(pageNum, pageSize);//设置分页信息
        JSONObject resJson=new JSONObject();
        List<CooperatorInfo> list= CooperatorService.selectCoop(cooperatorName);

        for(int i=0; i<list.size(); i++)
        {
            String time = list.get(i).getCreateTime().replace(".0","");
            list.get(i).setCreateTime(time);
        }
        PageInfo pageInfo=new PageInfo(list);
        resJson.put("select_cooperator_List",pageInfo);

        return Result.success("ok",resJson);
    }

    // 新增合作方
    @PostMapping("add")
    public Result cooperatorAdd(@RequestBody String json)
    {
        JSONObject req = JSON.parseObject(json);
        String cooperator_name=req.getString("cooperator_name");
        CooperatorInfo dupCooperatorInfo= CooperatorService.findByCooperatorNum(cooperator_name);
        if (dupCooperatorInfo!=null){
            return Result.error("合作方已存在！");
        }

        CooperatorInfo cooperatorInfo = new CooperatorInfo();
        cooperatorInfo.setCooperatorName(req.getString("cooperator_name"));
        long time1 = System.currentTimeMillis();
        cooperatorInfo.setCooperatorNum(Long.toString(time1));
        cooperatorInfo.setCorpCertificateNum(req.getString("corpCertificateNum"));
        cooperatorInfo.setCorpCertificateType(req.getString("corp_certificate_type"));
//        long time1 = System.currentTimeMillis();
//        cooperatorInfo.setCooperatorNum(Long.toString(time1));
        cooperatorInfo.setTemplateId(req.getString("field_template_id"));
        Calendar calendar= Calendar.getInstance();
        SimpleDateFormat dateFormat= new SimpleDateFormat("yyyy-MM-dd :HH:mm:ss");
        cooperatorInfo.setCreateTime(dateFormat.format(calendar.getTime()));
        // System.out.println(dateFormat.format(calendar.getTime()));
        CooperatorService.save(cooperatorInfo);

        return Result.success();
    }

    @PostMapping("edit")
    public Result cooperatorEdit(@RequestBody String json)
    {
        JSONObject req = JSON.parseObject(json);
        long cooperatorId=Long.valueOf(req.getString("cooperator_id")) ;


        CooperatorInfo cooperatorInfo = CooperatorService.findByID(cooperatorId);

        cooperatorInfo.setCooperatorName(req.getString("cooperator_name"));
        cooperatorInfo.setCooperatorNum(req.getString("cooperatorNum"));
        cooperatorInfo.setCorpCertificateType(req.getString("corp_certificate_type"));
        String oldTemplateId = cooperatorInfo.getTemplateId();
        String oldCooperatorNum = cooperatorInfo.getCooperatorNum();

        if(oldTemplateId!=req.getString("fieldTemplateId") && req.getString("fieldTemplateId")!="") {
            cooperatorInfo.setTemplateId(req.getString("fieldTemplateId"));
            List<CooperatorProduct> CooperatorProductList= CooperatorProductService.findCooperatorProductByNum(oldCooperatorNum);
            for (int i=0;i<CooperatorProductList.size();i++) {
                String coProductNum =  CooperatorProductList.get(i).getProductNum();
                List<CooperatorField> CooperatorFieldList = CooperatorProductService.findCooperatorProductFieldByNum(coProductNum);
                for (int j=0;j<CooperatorFieldList.size();j++) {
                    CooperatorProductFieldService.removeById(CooperatorFieldList.get(j).getId());
                }
            }
        }
        Calendar calendar= Calendar.getInstance();
        SimpleDateFormat dateFormat= new SimpleDateFormat("yyyy-MM-dd :hh:mm:ss");
        cooperatorInfo.setUpdateTime(dateFormat.format(calendar.getTime()));

        CooperatorService.updateById(cooperatorInfo);

        return Result.success();
    }

//    @GetMapping("findCooperatorListByName")
//    public Result findCooperatorListByName(String partnerName) {
//
//        JSONObject result = new JSONObject();
//        CooperatorInfo cooperatorInfo = CooperatorService.findByCooperatorNum(partnerName);
//
//        result.put("cooperatorName", cooperatorInfo.getCooperatorName());
//        result.put("fieldCount", cooperatorInfo.getFieldCount());
//        result.put("cooperatorNum", cooperatorInfo.getCooperatorNum());
//        result.put("modelCount", cooperatorInfo.getModelCount());
//        result.put("createTime", cooperatorInfo.getCreateTime());
//        return Result.success("ok", result);
//    }

    @RequestMapping("findCooperatorFieldByNum")
    public Result findCooperatorFieldByNum(@RequestBody String json) {
        JSONObject req = JSON.parseObject(json);
        int pageNum = req.getIntValue("pageNum");
        int pageSize = req.getIntValue("pageSize");
        String templateId = req.getString("templateId");
        PageHelper.startPage(pageNum, pageSize);//设置分页信息
        List<CooperatorField> list = CooperatorService.findCooperatorFieldByNum(templateId);
        for(int i=0; i<list.size(); i++)
        {
            String time = list.get(i).getCreateTime().replace(".0","");
            list.get(i).setCreateTime(time);
        }
        PageInfo pageInfo=new PageInfo(list);

        JSONObject resJson = new JSONObject();
        resJson.put("cooperator_field", pageInfo);
        return Result.success("ok", resJson);

    }

    @RequestMapping("findCooperatorFieldByCooNum")
    public Result findCooperatorFieldByCooNum(@RequestBody String json) {
        JSONObject req = JSON.parseObject(json);
        int pageNum = req.getIntValue("pageNum");
        int pageSize = req.getIntValue("pageSize");
        String cooperatorNum = req.getString("cooperatorNum");
        PageHelper.startPage(pageNum, pageSize);//设置分页信息
        List<CooperatorField> list = CooperatorService.findCooperatorFieldByCooNum(cooperatorNum);
        PageInfo pageInfo=new PageInfo(list);

        JSONObject resJson = new JSONObject();
        resJson.put("cooperator_field", pageInfo);
        return Result.success("ok", resJson);

    }

    @RequestMapping("findCooperatorProductByNum")
    public Result findCooperatorProductByNum(@RequestBody String json) {
        JSONObject req = JSON.parseObject(json);
        int pageNum = req.getIntValue("pageNum");
        int pageSize = req.getIntValue("pageSize");
        String cooperatorNum = req.getString("cooperatorNum");
        PageHelper.startPage(pageNum, pageSize);//设置分页信息
        List<CooperatorProduct> list = CooperatorService.findCooperatorProductByNum(cooperatorNum);
        PageInfo pageInfo=new PageInfo(list);
        JSONObject resJson = new JSONObject();
        resJson.put("cooperator_product", pageInfo);
        return Result.success("ok", resJson);


    }


    @GetMapping("list")
    public Result list(String partnerName) {

        QueryWrapper<CooperatorInfo> w = new QueryWrapper<>();
        if (!StringUtils.isEmpty(partnerName)) {
            w.like("partner_name", partnerName);
        }

        List<CooperatorInfo> list = CooperatorService.list(w);
        return Result.success("ok", list);
    }

    @PostMapping("partnerAdd")
    @Transactional
    public Result add(@RequestBody JSONObject param) {
//        String partnerName = param.getString("partnerName");
//        String contactName = param.getString("contactName");
//        String mobileNo = param.getString("mobileNo");
//        String rate1 = param.getString("rate1");
//        String queryNumber1 = param.getString("queryNumber1");
//        String rate2 = param.getString("rate2");
//        String queryNumber2 = param.getString("queryNumber2");
//        String rate3 = param.getString("rate3");
//        String queryNumber3 = param.getString("queryNumber3");
//        String isEnable = param.getString("isEnable");
//        PartnerInfo partnerInfo = new PartnerInfo();
//        partnerInfo.setPartnerName(partnerName);
//        partnerInfo.setContactName(contactName);
//        partnerInfo.setMobileNo(mobileNo);
//        partnerInfo.setRate1(rate1);
//        partnerInfo.setQueryNumber1(queryNumber1);
//        partnerInfo.setRate2(rate2);
//        partnerInfo.setQueryNumber2(queryNumber2);
//        partnerInfo.setRate3(rate3);
//        partnerInfo.setQueryNumber3(queryNumber3);
//        Date date = new Date();
//        partnerInfo.setCreateTime(date.toString());
//        partnerInfo.setIsEnable(isEnable);
//        PartnerInfoService.save(partnerInfo);

        return Result.success();
    }

}
