package com.kexun.controller;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.kexun.common.utils.Result;
import com.kexun.entity.*;
import com.kexun.service.CooperatorProductFieldService;
import com.kexun.service.CooperatorProductService;
import com.kexun.service.FieldDefineService;
import lombok.extern.java.Log;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

@RestController
@RequestMapping("/admin/cooperator_product")
@Log
public class CooperatorProductController {

    @Autowired
    FieldDefineService fieldDefineService;
    @Autowired
    private CooperatorProductService CooperatorProductService;

    @Autowired
    private com.kexun.service.CooperatorProductFieldService CooperatorProductFieldService;

    // 获取合作产品信息
    @RequestMapping("cooperatorProductList")

    public Result cooperatorProductList(@RequestBody String json) {
        JSONObject req = JSON.parseObject(json);
        int pageNum = req.getIntValue("pageNum");
        int pageSize = req.getIntValue("pageSize");
        PageHelper.startPage(pageNum, pageSize);//设置分页信息
        JSONObject resJson=new JSONObject();
        List<CooperatorProduct> list=CooperatorProductService.selectPage();

        for(int i=0; i<list.size(); i++)
        {
            String time = list.get(i).getCreateTime().replace(".0","");
            list.get(i).setCreateTime(time);
        }
        PageInfo pageInfo=new PageInfo(list);
        resJson.put("cooperator_Product_List",pageInfo);
        return Result.success("ok",resJson);
    }

    //模糊查询
    @RequestMapping("selectCoopProduct")

    public Result selectCoopProduct(@RequestBody String json) {
        JSONObject req = JSON.parseObject(json);
        int pageNum = req.getIntValue("pageNum");
        int pageSize = req.getIntValue("pageSize");
        String productName = req.getString("productName");

        PageHelper.startPage(pageNum, pageSize);//设置分页信息
        JSONObject resJson=new JSONObject();
        List<CooperatorProduct> list=CooperatorProductService.selectCoopProduct(productName);

        for(int i=0; i<list.size(); i++)
        {
            String time = list.get(i).getCreateTime().replace(".0","");
            list.get(i).setCreateTime(time);
        }
        PageInfo pageInfo=new PageInfo(list);
        resJson.put("select_cooperator_Product_List",pageInfo);

        return Result.success("ok",resJson);
    }

    @RequestMapping("getCooperatorByModel")
    public Result getCooperatorByModel(@RequestBody String json) {
        JSONObject req = JSON.parseObject(json);
        int pageNum = req.getIntValue("pageNum");
        int pageSize = req.getIntValue("pageSize");
        Long modelNo = req.getLongValue("modelNo");
        PageHelper.startPage(pageNum, pageSize);//设置分页信息
        JSONObject resJson=new JSONObject();
        List<CooperatorProduct> list=CooperatorProductService.getCooperatorByModel(modelNo);
        PageInfo pageInfo=new PageInfo(list);
        resJson.put("cooperator_Product_List",pageInfo);
        return Result.success("ok",resJson);

    }


    @RequestMapping("findCooperatorProductFieldByNum")
    public Result findCooperatorProductFieldByNum(@RequestBody String json) {
        JSONObject req = JSON.parseObject(json);
        int pageNum = req.getIntValue("pageNum");
        int pageSize = req.getIntValue("pageSize");
        String  productNum = req.getString("productNum");
        PageHelper.startPage(pageNum, pageSize);//设置分页信息
        JSONObject resJson=new JSONObject();
        List<CooperatorField> list = CooperatorProductService.findCooperatorProductFieldByNum(productNum);
        PageInfo pageInfo=new PageInfo(list);
        resJson.put("cooperator_product_field",pageInfo);
        return Result.success("ok",resJson);

    }
    // 获取合作产品字段
//    @GetMapping("findCooperatorProductFieldByNum/{productNum}")
//    public Result findCooperatorProductFieldByNum(@PathVariable("productNum") String productNum) {
//
//        JSONObject result = new JSONObject();
//        List<CooperatorField> list = CooperatorProductService.findCooperatorProductFieldByNum(productNum);
//        result.put("cooperator_product_field",list);
//
//        return Result.success("ok", result);
//    }

    // 申请合作产品
    @PostMapping("apply")
    public Result cooperatorProductApply(@RequestBody String json)
    {
        JSONObject req = JSON.parseObject(json);
        List<CooperatorProduct> dupCooperatorProductInfo=CooperatorProductService.getProductByProductNum(req.getString("product_num"));
        if(!dupCooperatorProductInfo.isEmpty()){
            return Result.error("合作方产品编号重复！");
        }


        CooperatorProduct cooperatorProduct = new CooperatorProduct();

        cooperatorProduct.setProductName(req.getString("product_name"));
        cooperatorProduct.setProductNum(req.getString("product_num"));
        cooperatorProduct.setCooperatorName(req.getString("cooperator_name"));
        cooperatorProduct.setCooperatorNum(req.getString("cooperator_num"));
        cooperatorProduct.setProductStatus("1");
        cooperatorProduct.setModelId(req.getString("model_id"));
        Calendar calendar= Calendar.getInstance();
        SimpleDateFormat dateFormat= new SimpleDateFormat("yyyy-MM-dd :HH:mm:ss");
        String createTime = dateFormat.format(calendar.getTime());
        cooperatorProduct.setCreateTime(createTime);
        CooperatorProductService.save(cooperatorProduct);
        Long id = cooperatorProduct.getId();

        //合作方产品字段关系表
        String fieldSelected = req.getString("fieldSelected");
        List<String> fieldSelectedList= JSONArray.parseArray(fieldSelected,String.class);
        List<CooperatorProductField> cooperatorProductFieldList = new ArrayList<>();

        for (int i=0;i<fieldSelectedList.size();i++){
            Long fid = Long.parseLong(fieldSelectedList.get(i));
            FieldDefineEntity fieldDefine = fieldDefineService.findByID(fid);
            CooperatorProductField cooperatorProductField = new CooperatorProductField();
            cooperatorProductField.setIsDeleted(false);
            cooperatorProductField.setFieldId(fieldDefine.getId());
            cooperatorProductField.setFieldNo(fieldDefine.getFieldNo());
            cooperatorProductField.setName(fieldDefine.getName());
            cooperatorProductField.setProductId(id.toString());
            cooperatorProductField.setProductNum(req.getString("product_num"));
            cooperatorProductField.setProductName(req.getString("product_name"));
            CooperatorProductFieldService.save(cooperatorProductField);
        }

        return Result.success();
    }

    //修改合作产品
    @PostMapping("editApply")
    public Result editApply(@RequestBody String json)
    {
        JSONObject req = JSON.parseObject(json);
        //原有合作方产品字段关系表
        String fieldSelectedOld = req.getString("fieldSelectedOld");
        List<String> fieldSelectedOldList= JSONArray.parseArray(fieldSelectedOld,String.class);
        for (int i=0;i<fieldSelectedOldList.size();i++){
            Long foid = Long.parseLong(fieldSelectedOldList.get(i));
            System.out.println("this id ");
            System.out.println(foid);
            CooperatorProductFieldService.removeById(foid);
        }

        //合作方产品字段关系表
        String fieldSelected = req.getString("fieldSelected");
        List<String> fieldSelectedList= JSONArray.parseArray(fieldSelected,String.class);

        for (int i=0;i<fieldSelectedList.size();i++){
            Long fid = Long.parseLong(fieldSelectedList.get(i));
            FieldDefineEntity fieldDefine = fieldDefineService.findByID(fid);
            CooperatorProductField cooperatorProductField = new CooperatorProductField();
            cooperatorProductField.setIsDeleted(false);
            cooperatorProductField.setFieldId(fieldDefine.getId());
            cooperatorProductField.setFieldNo(fieldDefine.getFieldNo());
            cooperatorProductField.setName(fieldDefine.getName());
            cooperatorProductField.setProductId(req.getString("productId"));
            cooperatorProductField.setProductNum(req.getString("productNum"));
            cooperatorProductField.setProductName(req.getString("productName"));
            CooperatorProductFieldService.save(cooperatorProductField);
        }

        return Result.success();
    }

    @GetMapping("updateProductFieldNo/{productNum}/{fieldNo}")
    public Result updateProductFieldNo(@PathVariable("productNum") String productNum,@PathVariable("fieldNo")  String fieldNo) {
        JSONObject result = new JSONObject();
        CooperatorProductService.updateProductFieldNo(productNum,fieldNo);
        return Result.success("ok", result);
    }

    @GetMapping("findCooperatorFieldsByName/{cooperatorName}")
    public Result findCooperatorFieldsByName(@PathVariable("cooperatorName") String cooperatorName){
        JSONObject resJson=new JSONObject();
        List<CooperatorField> list=CooperatorProductService.findCooperatorFieldsByName(cooperatorName);
        resJson.put("cooperator_fields_by_name",list);

        return Result.success("ok",resJson);
    }

}
