package com.kexun.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * Description: 模型实体类
 *
 * @author lgs
 * @date 2023/12/08
 */
@TableName(value = "model")
@Data
public class ModelEntity extends BaseEntity implements Serializable {

    @TableField(value = "model_name")
    private String modelName;

    @TableField(value = "model_no")
    private String modelNo;

    @TableField(value = "status")
    private String status;

    /**
     * 0  自定义模型
     * 1  jar包
     * 2  python包
     * 3  http服务
     */
    @TableField(value = "model_type")
    private int modelType;

    @TableField(value = "model_rule")
    private String modelRule;

    @TableField(value = "file_path")
    private String filePath;

//    @TableField(value = "create_by")
//    private String userName;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    public Date getCreateTime(){
        return super.getCreateTime();
    }

}
