package com.kexun.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 非信贷交易信息明细
 * </p>
 *
 * @author lgs
 * @since 2023-06-12
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_nct_trs_base")
@ApiModel(value="NctTrsBaseEntity对象", description="非信贷交易信息明细")
public class NctTrsBaseEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "证件号码")
    @TableField("id_num")
    private String idNum;

    @ApiModelProperty(value = "业务编号")
    @TableField("acct_no")
    private String acctNo;

    @ApiModelProperty(value = "后付费账户类型代码")
    @TableField("acc_type_code")
    private String accTypeCode;

    @ApiModelProperty(value = "后付费账户类型描述")
    @TableField("acc_type_desc")
    private String accTypeDesc;

    @ApiModelProperty(value = "机构名称")
    @TableField("org_name")
    private String orgName;

    @ApiModelProperty(value = "业务类型代码")
    @TableField("busi_type_code")
    private String busiTypeCode;

    @ApiModelProperty(value = "业务类型描述")
    @TableField("busi_type_desc")
    private String busiTypeDesc;

    @ApiModelProperty(value = "业务开通日期")
    @TableField("busi_open_date")
    private String busiOpenDate;

    @ApiModelProperty(value = "当前缴费状态代码")
    @TableField("pay_status_code")
    private String payStatusCode;

    @ApiModelProperty(value = "当前缴费状态描述")
    @TableField("pay_status_desc")
    private String payStatusDesc;

    @ApiModelProperty(value = "当前欠费金额")
    @TableField("owe_amt")
    private BigDecimal oweAmt;

    @ApiModelProperty(value = "记账年月")
    @TableField("acc_year_month")
    private String accYearMonth;

    @ApiModelProperty(value = "最近24个月缴费记录")
    @TableField("pay_record")
    private String payRecord;


}
