package com.kexun.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 行政处罚记录
 * </p>
 *
 * @author lgs
 * @since 2023-06-13
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_pub_penaltyl")
@ApiModel(value="PubPenaltylEntity对象", description="行政处罚记录")
public class PubPenaltylEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "证件号码")
    @TableField("id_num")
    private String idNum;

    @ApiModelProperty(value = "处罚机构")
    @TableField("punish_org")
    private String punishOrg;

    @ApiModelProperty(value = "处罚内容")
    @TableField("punish_con")
    private String punishCon;

    @ApiModelProperty(value = "处罚金额")
    @TableField("punish_amt")
    private BigDecimal punishAmt;

    @ApiModelProperty(value = "处罚生效日期")
    @TableField("pun_start_date")
    private String punStartDate;

    @ApiModelProperty(value = "处罚截止日期")
    @TableField("pun_end_date")
    private String punEndDate;

    @ApiModelProperty(value = "行政复议结果")
    @TableField("rec_result")
    private String recResult;


}
