package com.kexun.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 非信贷交易信息概要
 * </p>
 *
 * @author lgs
 * @since 2023-06-08
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_smry_no_credit")
@ApiModel(value="SmryNoCreditEntity对象", description="非信贷交易信息概要")
public class SmryNoCreditEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "证件号码")
    @TableField("id_num")
    private String idNum;

    @ApiModelProperty(value = "后付费业务类型代码")
    @TableField("pi_type_code")
    private String piTypeCode;

    @ApiModelProperty(value = "后付费业务类型描述")
    @TableField("pi_type_desc")
    private String piTypeDesc;

    @ApiModelProperty(value = "欠费账户数")
    @TableField("arr_acc_num")
    private Integer arrAccNum;

    @ApiModelProperty(value = "欠费金额")
    @TableField("arr_amount")
    private BigDecimal arrAmount;


}
