package com.kexun.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 信用报告数字解读信息
 * </p>
 *
 * @author lgs
 * @since 2023-05-31
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_smry_num_read")
@ApiModel(value="SmryNumReadEntity对象", description="信用报告数字解读信息")
public class SmryNumReadEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "相对位置")
    @TableField("relposition")
    private String relposition;

    @ApiModelProperty(value = "数字解读")
    @TableField("number_read")
    private Integer numberRead;

    @ApiModelProperty(value = "分数说明条数")
    @TableField("score_explain_num")
    private Integer scoreExplainNum;

    @ApiModelProperty(value = "分数说明")
    @TableField("score_explain")
    private String scoreExplain;


}
