package com.kexun.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 查询记录概要
 * </p>
 *
 * @author lgs
 * @since 2023-06-09
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_smry_query_record")
@ApiModel(value="SmryQueryRecordEntity对象", description="查询记录概要")
public class SmryQueryRecordEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "证件号码")
    @TableField("id_num")
    private String idNum;

    @ApiModelProperty(value = "上一次查询日期")
    @TableField("last_query_date")
    private String lastQueryDate;

    @ApiModelProperty(value = "上一次查询机构类型代码")
    @TableField("last_org_type_code")
    private String lastOrgTypeCode;

    @ApiModelProperty(value = "上一次查询机构类型描述")
    @TableField("last_org_type_desc")
    private String lastOrgTypeDesc;

    @ApiModelProperty(value = "上一次查询机构代码")
    @TableField("last_org_code")
    private String lastOrgCode;

    @ApiModelProperty(value = "上一次查询原因代码")
    @TableField("last_query_reason_code")
    private String lastQueryReasonCode;

    @ApiModelProperty(value = "上一次查询原因描述")
    @TableField("last_query_reason_desc")
    private String lastQueryReasonDesc;

    @ApiModelProperty(value = "最近 1 个月内的查询机构数（贷款审批）")
    @TableField("last_1m_org_sp")
    private Integer last1mOrgSp;

    @ApiModelProperty(value = "最近 1 个月内的查询机构数（信用卡审批）")
    @TableField("last_1m_credit_sp")
    private Integer last1mCreditSp;

    @ApiModelProperty(value = "最近 1 个月内的查询次数（贷款审批）")
    @TableField("num_sp")
    private Integer numSp;

    @ApiModelProperty(value = "最近 1 个月内的查询次数（信用卡审批）")
    @TableField("num_credit_sp")
    private Integer numCreditSp;

    @ApiModelProperty(value = "最近 1 个月内的查询次数（本人查询）")
    @TableField("last_1month_num_self")
    private Integer last1monthNumSelf;

    @ApiModelProperty(value = "最近2年的查询次数（贷后管理）")
    @TableField("last_2year_num_dh")
    private Integer last2yearNumDh;

    @ApiModelProperty(value = "最近2年的查询次数（担保资格审查）")
    @TableField("last_2year_num_dbzg")
    private Integer last2yearNumDbzg;

    @ApiModelProperty(value = "最近2年的查询次数（特约商户实名审查）")
    @TableField("last_2year_num_tysh")
    private Integer last2yearNumTysh;


}
