package com.kexun.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 特殊交易信息
 * </p>
 *
 * @author lgs
 * @since 2023-06-12
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_trs_spec")
@ApiModel(value="TrsSpecEntity对象", description="特殊交易信息")
public class TrsSpecEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "证件号码")
    @TableField("id_num")
    private String idNum;

    @ApiModelProperty(value = "账户编号")
    @TableField("acct_no")
    private String acctNo;

    @ApiModelProperty(value = "特殊交易类型代码")
    @TableField("tran_type_code")
    private String tranTypeCode;

    @ApiModelProperty(value = "特殊交易类型描述")
    @TableField("tran_type_desc")
    private String tranTypeDesc;

    @ApiModelProperty(value = "特殊交易发生日期")
    @TableField("tran_date")
    private String tranDate;

    @ApiModelProperty(value = "特殊交易变更月数")
    @TableField("tran_month")
    private Integer tranMonth;

    @ApiModelProperty(value = "特殊交易发生金额")
    @TableField("tran_amt")
    private BigDecimal tranAmt;

    @ApiModelProperty(value = "特殊交易明细记录")
    @TableField("det_record")
    private String detRecord;


}
