package com.kexun.model.xml.pub;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;

import java.math.BigDecimal;

/**
 * Description:住房公积金参缴记录
 *
 * @author lgs
 * @date 2023/06/13
 */
@Data
public class PubHousingFundInf {

    /**
     * 参缴地代码
     */
    @JSONField(name ="ADDRESSCODE")
    private String addressCode;

    /**
     * 参缴地描述
     */
    @JSONField(name ="ADDRESSDESC")
    private String addressDesc;

    /**
     * 参缴日期
     */
    @JSONField(name ="PAYDATE")
    private String payDate;

    /**
     * 缴费状态代码
     */
    @JSONField(name ="STATUSCODE")
    private String statusCode;

    /**
     * 缴费状态描述
     */
    @JSONField(name ="STATUSDESC")
    private String statusDesc;

    /**
     * 初缴月份
     */
    @JSONField(name ="BEGINMONTH")
    private String beginMonth;

    /**
     * 缴至月份
     */
    @JSONField(name ="ENDMONTH")
    private String endMonth;

    /**
     * 单位缴存比例
     */
    @JSONField(name ="COMPROPORTION")
    private String comProportion;

    /**
     * 个人缴存比例
     */
    @JSONField(name ="PEPROPORTION")
    private String peProportion;

    /**
     * 月缴存额
     */
    @JSONField(name ="MONTHMONEY")
    private BigDecimal monthMoney;

    /**
     * 缴费单位
     */
    @JSONField(name ="COMPANY")
    private String company;

    /**
     * 信息更新日期
     */
    @JSONField(name = "UPDATEDATE")
    private String updateDate;
}
