package com.kexun.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.kexun.entity.ReportInfo;
import com.kexun.model.dto.ReportInfoDTO;
import com.kexun.model.ro.ReportInfoRO;

import java.util.List;

/**
 * <p>
 * 报文信息 服务类
 * </p>
 *
 * @author lgs
 * @since 2023-05-10
 */
public interface ReportInfoService extends IService<ReportInfo> {

    /**
     * 保存报文信息
     *
     * @param reportInfo
     */
    void saveReportInfo(ReportInfo reportInfo);

    /**
     * 修改报文信息
     * @param reportInfoDTO
     */
    void updateReportInfo(ReportInfoDTO reportInfoDTO);

    /**
     * 修改报文信息
     * @param status
     * @param id
     */
    void updateReportInfoStatus(String status,Long id);

    /**
     * 根据条件获取报文信息
     * @return
     */
    List<ReportInfo> listReportInfo(ReportInfoDTO reportInfoDTO);


}
