package com.kexun.service.xml;

import com.kexun.entity.SmryQueryRecordEntity;
import com.kexun.model.dto.CommonParam;
import com.kexun.model.xml.IXmlBase;
import com.kexun.model.xml.LastMounthQueryRecord;
import com.kexun.model.xml.LastQueryRecord;
import com.kexun.model.xml.SmryQueryRecord;
import com.kexun.service.SmryQueryRecordService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Description:查询记录概要
 *
 * @author lgs
 * @date 2023/06/09
 */
@Service
public class SmryQueryRecordHandlerService implements IHandleXmlBaseService {

    @Autowired
    SmryQueryRecordService smryQueryRecordService;

    @Override
    public void handleXmlSgmt(CommonParam commonParam, IXmlBase reportXmlBase) {

        if (reportXmlBase instanceof SmryQueryRecord) {
            SmryQueryRecord smryQueryRecord = (SmryQueryRecord) reportXmlBase;
            SmryQueryRecordEntity smryQueryRecordEntity = new SmryQueryRecordEntity();
            LastQueryRecord lastQueryRecord = smryQueryRecord.getLastQueryRecord();
            LastMounthQueryRecord lastMounthQueryRecord = smryQueryRecord.getLastMounthQueryRecord();
            if (lastQueryRecord != null && lastMounthQueryRecord != null) {
                BeanUtils.copyProperties(lastQueryRecord, smryQueryRecordEntity);
                BeanUtils.copyProperties(lastMounthQueryRecord, smryQueryRecordEntity);

                smryQueryRecordEntity.setHeadInfId(commonParam.getHeadInfId());
                smryQueryRecordEntity.setIdNum(commonParam.getIdNum());
                smryQueryRecordEntity.setName(commonParam.getName());
                smryQueryRecordEntity.setRptNo(commonParam.getRptNo());
                smryQueryRecordService.save(smryQueryRecordEntity);
            }

        }
    }
}
